/* Example: simple file operations */

/* No error checking is done, so the program may fail! 
All practical programs should check file operations. */

#include <stdio.h>
#include <stdlib.h>

int main(void)
{
  FILE *pf;  /* file pointer, or stream */
  char str[40];
  int n;
  char c;
  
  pf = fopen("myfile.old", "w");       /* open a file for writing */
  fputs("Hello world!\n", pf);         /* write to the file */
  fclose(pf);                          /* close the file */
  
  rename("myfile.old", "myfile.new");  /* rename the file */

  pf = fopen("myfile.new", "a");       /* open file for appending */
  fprintf(pf, "Hello again! ");        /* write string */
  fprintf(pf, "%i ", 123);             /* write number */
  fputc('#', pf); fputc('\n', pf);     /* write characters */ 
  fclose(pf);                          /* close the file */
  
  pf = fopen("myfile.new", "r");       /* open file for reading */
  fgets(str, 40, pf);                  /* read a line */
  printf(str);                         /* print it to the screen */
  
  rewind(pf);                          /* rewind file to start */
  fgets(str, 40, pf);                  /* read a line */
  printf(str);                         /* print it to the screen */
  
  fscanf(pf, "%s", str);               /* read a word */
  printf(str);                         /* print it to the screen */
  putchar('\n');
  fscanf(pf, "%s", str);               /* ...another word */
  printf("%s\n", str);
  
  fscanf(pf, "%i", &n);                /* ...a number */
  printf("%i\n", n);
  
  c = fgetc(pf); putchar(c);           /* ...some characters */
  c = fgetc(pf); putchar(c);
  c = fgetc(pf); putchar(c);

  fclose(pf);                          /* close the file */
  remove("myfile.new");                /* delete the file */

  return EXIT_SUCCESS;
}
